#include <iostream>
#include <fstream>
using namespace std;
#define MN 30
#define MM 30
char park[MN][MM];
bool was[MN][MM];
int n,m;
struct point
{
	int x;
	int y;
	int step;
};
void clear_was()
{
	for(int i=0;i<MN;i++)
		for(int j=0;j<MM;j++)
			was[i][j]=false;
}
int go(point start, point queen)
{
	clear_was();
	int dx[]={0,1,0,-1};
	int dy[]={1,0,-1,0};
	point way[MN*MM];
	int wcount=1;
	way[0]=start;
	for(int i=0;i<wcount;i++)
	{
		if((way[i].x<0) || (way[i].y<0))
			continue;
		if((way[i].x>=n) || (way[i].y>=m))
			continue;
		if(was[way[i].x][way[i].y])
			continue;
		if(park[way[i].x][way[i].y]=='1')
			continue;
		if((way[i].x==queen.x)&&(way[i].y==queen.y))
			return way[i].step;
		was[way[i].x][way[i].y]=true;
		for(int j=0;j<4;j++)
		{
			way[wcount].x=way[i].x+dx[j];
			way[wcount].y=way[i].y+dy[j];
			way[wcount].step=way[i].step+1;
			wcount++;
		}
	}
	return -1;
}
int main()
{
	ifstream in("heroes.in");
	int test;
	point musk,queen;
	int count,all_count;
	int cur_time, max_time;
	in >> test;
	while(test)
	{
		test--;
		in >> n >> m;
		for(int i=0;i<n;i++)
			in >> park[i];
		in >> queen.x >> queen.y;
		in >> max_time;
		queen.x--;
		queen.y--;
		all_count=0;
		for(int i=0;i<4;i++)
		{
			in >> musk.x >> musk.y >> count;
			musk.x--;
			musk.y--;
			musk.step=0;
			cur_time=go(musk,queen);
			if (cur_time>=0 && cur_time<=max_time)
				all_count+=count;
			//cout << '\t' << cur_time << endl;
		}
		cout << all_count << endl;
	}
}