import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;
import java.util.Random;
import java.lang.Math;

class Square {
	public static long isSquare(long a, long b){
		long c = (long)Math.sqrt((double) a * b);
		return c * c == a * b ? c : 0;
	}
	
	public static void main(String[] args) throws FileNotFoundException{
		Scanner in = new Scanner(new File("square.in"));
		int tests = in.nextInt();

		while( tests-- > 0 ){
			long a, b;
			a = in.nextLong();
			b = in.nextLong();
		
			System.out.println(isSquare(a, b));
		}
	}
}
